(* 
 *  OCaml datatypes that we use to represent
 *  a simple, imperative programming language. 
 *)

(*
 *
 * Recall the BNF grammar for this simple language:
 *
 *  <exp> ::= 
 *         |  <X>
 *         |  <exp> + <exp>
 *         |  <exp> * <exp>
 *         |  <exp> < <exp>
 *         |  <integer contant>
 *         |  (<exp>)
 *
 *  <cmd> ::= 
 *         |  skip
 *         |  <X> = <exp>
 *         |  ifNZ <exp> { <cmd> } else { <cmd> }
 *         |  whileNZ <exp> { <cmd> }
 *         |  <cmd>; <cmd>
 *
 *)

